#ifndef AXPATH_LIBXML_INTERNAL_H
#define AXPATH_LIBXML_INTERNAL_H

/**
 * Copyright (c) 2016  Peter Pentchev
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

struct axpath_libxml_pattern {
	char *full;
	size_t f_count, f_alloc;
	xmlChar **frag;

	size_t m_count, m_alloc;
	size_t *m_length;
	xmlChar **matches;
};

struct axpath_libxml_seek;

struct axpath_libxml_parser {
	void (*start_element)(struct axpath_libxml_seek *seek, const xmlChar *name, const xmlChar **attrs);
	void (*end_element)(struct axpath_libxml_seek *seek);
	void (*characters)(struct axpath_libxml_seek *seek, const xmlChar *chars, size_t len);
};

struct axpath_libxml_state;

struct axpath_libxml_seek {
	struct axpath_libxml_pattern *pattern;
	size_t c_valid, c_invalid;

	struct axpath_libxml_state *state;

	const struct axpath_libxml_parser *parser;
};

struct axpath_libxml_state {
	axpath_found_handler found;
	axpath_missing_handler missing;
	axpath_error_handler error;

	struct axpath_libxml_pattern *patterns;
	size_t p_count, p_alloc;

	xmlParserCtxtPtr parser_context;

	size_t s_count;
	struct axpath_libxml_seek *seek;

	void (*end_document)(const struct axpath_libxml_state *);
};

#endif
